# Load all Hash core extensions.

if RUBY_VERSION < '1.9'
  require "facets/hash/alias.rb"
  require "facets/hash/argumentize.rb"
  require "facets/hash/at.rb"
  require "facets/hash/autonew.rb"
  require "facets/hash/collate.rb"
  require "facets/hash/count.rb"
  require "facets/hash/data.rb"
  require "facets/hash/dearray_values.rb"
  require "facets/hash/deep_merge.rb"
  require "facets/hash/delete.rb"
  require "facets/hash/delete_at.rb"
  require "facets/hash/delete_unless.rb"
  require "facets/hash/delete_values.rb"
  require "facets/hash/diff.rb"
  require "facets/hash/except.rb"
  require "facets/hash/graph.rb"
  require "facets/hash/insert.rb"
  require "facets/hash/inverse.rb"
  require "facets/hash/join.rb"
  require "facets/hash/keys.rb"
  require "facets/hash/mash.rb"
  require "facets/hash/new_with.rb"
  require "facets/hash/op.rb"
  require "facets/hash/op_add.rb"
  require "facets/hash/op_and.rb"
  require "facets/hash/op_mul.rb"
  require "facets/hash/op_or.rb"
  require "facets/hash/op_push.rb"
  require "facets/hash/op_sub.rb"
  require "facets/hash/recurse.rb"
  require "facets/hash/recursively.rb"
  require "facets/hash/rekey.rb"
  require "facets/hash/replace_each.rb"
  require "facets/hash/reverse_merge.rb"
  require "facets/hash/select.rb"
  require "facets/hash/slice.rb"
  require "facets/hash/stringify_keys.rb"
  require "facets/hash/subset.rb"
  require "facets/hash/swap.rb"
  require "facets/hash/symbolize_keys.rb"
  require "facets/hash/to_h.rb"
  require "facets/hash/to_mod.rb"
  require "facets/hash/to_options.rb"
  require "facets/hash/to_proc.rb"
  require "facets/hash/to_struct.rb"
  require "facets/hash/traverse.rb"
  require "facets/hash/update.rb"
  require "facets/hash/update_each.rb"
  require "facets/hash/update_keys.rb"
  require "facets/hash/update_values.rb"
  require "facets/hash/weave.rb"
  require "facets/hash/zip.rb"
else
  require_relative "hash/alias.rb"
  require_relative "hash/argumentize.rb"
  require_relative "hash/at.rb"
  require_relative "hash/autonew.rb"
  require_relative "hash/collate.rb"
  require_relative "hash/count.rb"
  require_relative "hash/data.rb"
  require_relative "hash/dearray_values.rb"
  require_relative "hash/deep_merge.rb"
  require_relative "hash/delete.rb"
  require_relative "hash/delete_at.rb"
  require_relative "hash/delete_unless.rb"
  require_relative "hash/delete_values.rb"
  require_relative "hash/diff.rb"
  require_relative "hash/except.rb"
  require_relative "hash/graph.rb"
  require_relative "hash/insert.rb"
  require_relative "hash/inverse.rb"
  require_relative "hash/join.rb"
  require_relative "hash/keys.rb"
  require_relative "hash/mash.rb"
  require_relative "hash/new_with.rb"
  require_relative "hash/op.rb"
  require_relative "hash/op_add.rb"
  require_relative "hash/op_and.rb"
  require_relative "hash/op_mul.rb"
  require_relative "hash/op_or.rb"
  require_relative "hash/op_push.rb"
  require_relative "hash/op_sub.rb"
  require_relative "hash/recurse.rb"
  require_relative "hash/recursively.rb"
  require_relative "hash/rekey.rb"
  require_relative "hash/replace_each.rb"
  require_relative "hash/reverse_merge.rb"
  require_relative "hash/select.rb"
  require_relative "hash/slice.rb"
  require_relative "hash/stringify_keys.rb"
  require_relative "hash/subset.rb"
  require_relative "hash/swap.rb"
  require_relative "hash/symbolize_keys.rb"
  require_relative "hash/to_h.rb"
  require_relative "hash/to_mod.rb"
  require_relative "hash/to_options.rb"
  require_relative "hash/to_proc.rb"
  require_relative "hash/to_struct.rb"
  require_relative "hash/traverse.rb"
  require_relative "hash/update.rb"
  require_relative "hash/update_each.rb"
  require_relative "hash/update_keys.rb"
  require_relative "hash/update_values.rb"
  require_relative "hash/weave.rb"
  require_relative "hash/zip.rb"
end

